/* File:    Tachometer_gcc.h
 * 
 * Author:  David Zemon
 * Project: Tachometer_gcc
 */

#ifndef TACHOMETER_GCC_H_
#define TACHOMETER_GCC_H_

#include <propeller.h>
#include <stdio.h>
#include <types.h>
#include <gpio.h>

// Tachometer constants
#define TACH_PIN		BIT_18		// Which pin is connected
#define	ARRAY_SIZE		16			// Number of ticks to count in the average
#define	LOG_SIZE		4			// LOG_2(DEFAULT_AVG)
#define TEST_LED		BIT_16
#define	TEST_LED_2		BIT_17

#define RS				0
#define RW				1
#define E				2
#define DB0				8
#define DB7				15

#define TICKS_PER_REV	2             // Number of rising edges on tachometer signal per revolution

#define REFRESH_FREQ	4             // Frequency to refresh the LCD (in Hz) (default = 4)
#define MAX_RPM			99999

#define printf			__simple_printf

/*****************************
 *** Function Declarations ***
 *****************************/
void sysInit (uint8 *asmCog, float *divisor);

void tachometer (void);

#endif /* TACHOMETER_GCC_H_ */
