
#include <gpio.h>										'' Includes definitions for BIT_x
#define	_TACH_PIN	BIT_18
#define TEST_OUT	BIT_16
#define TEST_OUT2	BIT_17

#define ARRAY_SIZE	16
#define LOG_SIZE	4

				.section .cogtachometer, "ax"
				.cog_ram

entry					waitpeq tachPin, tachPin		'' Ignore first period
						waitpeq zero, tachPin
						mova wPtr, #array				'' Set pointer to first address in the array
						mov sum, #0
						mov old, cnt					'' Initialize old cnt value
						sub zero, #1 wc, nr				'' Set the C flag
						or dira, testLED
						or dira, testLED2

						'' Wait for input to go high, store the time delay
loop					waitpeq tachPin, tachPin		'' Wait until pin goes high
						mov new, cnt					'' Save system count register
						waitpeq zero, tachPin			'' Wait until pin goes low again
						mov count, new
						sub count, old					'' Calculate time (in osc tick) between rpm ticks
						mov old, new

						'' Subtract the old value, add the new one (only if array full)
			if_nc		movs decArray, wPtr
						add sum, count
decArray	if_nc		sub sum, 0-0

						'' Store a new value into the array
						movd storeCnt, wPtr				'' Store the current pointer address into the move instruction
						add offset, #1					'' Increment the pointer
						cmp offset, #ARRAY_SIZE wc		'' If we've made it past the end of the array...
			if_ae		mov offset, #0					'' Reset the offset to the beginning of the array
			if_ae		xor outa, testLED2
						mova wPtr, #array
						add wPtr, offset
storeCnt				mov 0-0, count					'' Store the count into the array

						xor outa, testLED

						'' Add more values to the array if not full
loopCnt		if_c		add loops, #1
			if_c		cmp loops, #ARRAY_SIZE wc
			if_c		jmp #loop

						'' Write data to hub memory
						mov tempAsm, sum
						shr tempAsm, #LOG_SIZE
						wrlong tempAsm, par				'' Write to HUB RAM
						jmp #loop

tachPin					long	_TACH_PIN
testLED					long	TEST_OUT
testLED2				long	TEST_OUT2
zero					long	0
loops					long	0
offset					long	0						'' Pointer offset

sum						res		1
old						res		1
new						res		1
count					res		1
array					res		ARRAY_SIZE				'' Rolling sum array
wPtr					res		1						'' Write pointer to array
tempAsm					res		1
